// WavListView.cpp : CWavListView NX̓̒`s܂B
//

#include "stdafx.h"
#include "WavList.h"

#include "WavListDoc.h"
#include "WavListView.h"
#include "VolCtrl.h"
#include "StatusDialog.h"
#include "SkipWave.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWavListView

IMPLEMENT_DYNCREATE(CWavListView, CListView)

BEGIN_MESSAGE_MAP(CWavListView, CListView)
	//{{AFX_MSG_MAP(CWavListView)
	ON_WM_DROPFILES()
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	ON_COMMAND(ID_WAVE_PLAY, OnWavePlay)
	ON_UPDATE_COMMAND_UI(ID_WAVE_PLAY, OnUpdateWavePlay)
	ON_COMMAND(ID_WAVE_STOP, OnWaveStop)
	ON_UPDATE_COMMAND_UI(ID_WAVE_STOP, OnUpdateWaveStop)
	ON_WM_CREATE()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_COMMAND(ID_WAVE_VOLREG, OnWaveVolreg)
	ON_COMMAND(ID_WAVE_VOLUME, OnWaveVolume)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_MERGE, OnFileMerge)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_WAVE_CUT, OnWaveCut)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	// WR}h
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

static	int			CompareRevs = 0;
static	int			CompareDups = 0;
static	int			LastSortItem = (-1);
static	CListCtrl	*pCompList = NULL;

static	int CALLBACK	CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	int i1, i2, it;
	CString s1, s2;
	LV_FINDINFO lvinfo;

	lvinfo.flags = LVFI_PARAM;
	lvinfo.lParam = lParam1;
	i1 = pCompList->FindItem(&lvinfo);
	lvinfo.lParam = lParam2;
	i2 = pCompList->FindItem(&lvinfo);

	if ( i1 == (-1) || i2 == (-1) )
		return 0;

	if ( CompareRevs ) {
		it = i1;
		i1 = i2;
		i2 = it;
	}

	s1 = pCompList->GetItemText(i1, (int)lParamSort);
	s2 = pCompList->GetItemText(i2, (int)lParamSort);
	if ( (it = s1.Compare(s2)) != 0 || lParamSort == CompareDups )
		return it;

	s1 = pCompList->GetItemText(i1, CompareDups);
	s2 = pCompList->GetItemText(i2, CompareDups);
	return s1.Compare(s2);
}

/////////////////////////////////////////////////////////////////////////////
// CWavListView NX̍\z/

CWavListView::CWavListView()
{
	waveTabEntry = 0;
	waveTabSize = 16;
	waveTabBuff = new CWaveFile * [waveTabSize];
	for ( int n = 0 ; n < waveTabSize ; n++ )
		waveTabBuff[n] = NULL;
	playWave = NULL;
}

CWavListView::~CWavListView()
{
	OnWaveStop();
	for ( int n = 0 ; n < waveTabSize ; n++ ) {
		if ( waveTabBuff[n] != NULL )
			delete waveTabBuff[n];
	}
	delete waveTabBuff;
}

BOOL CWavListView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWavListView NX̕`

void CWavListView::OnDraw(CDC* pDC)
{
	CWavListDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
}

void CWavListView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	DragAcceptFiles(TRUE);

	int n;
	static LV_COLUMN lvt[] = {
		{ LVCF_TEXT | LVCF_WIDTH, 0, 200, "File Name",	0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Channel",	0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Freq",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Bits",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Size",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Time",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "Level",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "FeedIn",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "FeedOut",	0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "SkipIn",		0, 0 }, 
		{ LVCF_TEXT | LVCF_WIDTH, 0,  70, "SkipOut",	0, 0 }, 
	};

	GetListCtrl().DeleteAllItems();
	while ( GetListCtrl().DeleteColumn(0) );

	for ( n = 0 ; n < 11 ; n++ )
		GetListCtrl().InsertColumn(n, &lvt[n]);

	GetListCtrl().ModifyStyle(0, LVS_REPORT, 1);
//	GetListCtrl().SetExtendedStyle(0);
}

/////////////////////////////////////////////////////////////////////////////
// CWavListView NẌ

BOOL CWavListView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

void CWavListView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: O̓ʂȏǉĂB
}

void CWavListView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: ̌㏈ǉĂB
}

/////////////////////////////////////////////////////////////////////////////
// CWavListView NX̐ff

#ifdef _DEBUG
void CWavListView::AssertValid() const
{
	CListView::AssertValid();
}

void CWavListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CWavListDoc* CWavListView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWavListDoc)));
	return (CWavListDoc*)m_pDocument;
}
#endif //_DEBUG

void CWavListView::AddFile(CString file)
{
	int n, entry;
	int cha, freq, bits;
	long size, sec;
	int id = GetListCtrl().GetItemCount();
	CString str;
	CWaveFile *wave;

	if ( waveTabEntry >= waveTabSize ) {
		CWaveFile **tmp;
		waveTabSize;
		if ( (tmp = new CWaveFile * [waveTabSize + 16]) == NULL ) {
			MessageBox("WaveTab Memory alloc error");
			return;
		}
		memcpy(tmp, waveTabBuff, waveTabSize);
		delete waveTabBuff;
		waveTabBuff = tmp;
		for ( n = waveTabSize ; n < (waveTabSize + 16) ; n++ )
			waveTabBuff[n] = NULL;
		waveTabSize += 16;
	}

	wave = new CWaveFile(this);
	waveTabBuff[waveTabEntry] = wave;
	entry = waveTabEntry++;

	if ( !wave->InitFile(file) ) {
		MessageBox("Wavet@CƔFł܂ł");
		waveTabEntry--;
		waveTabBuff[entry] = NULL;
		delete wave;
		return;
	}

	cha  = wave->waveFormat.nChannels;
	freq = wave->waveFormat.nSamplesPerSec;
	bits = wave->waveFormat.wBitsPerSample;
	size = wave->waveSize;

	n = file.ReverseFind('\\');
	GetListCtrl().InsertItem(LVIF_TEXT | LVIF_PARAM, id, file.Mid(n + 1), 0, 0, 0, entry);
	str.Format("%d", cha);
	GetListCtrl().SetItemText(id, 1, str);
	str.Format("%dKHz", freq / 1000);
	GetListCtrl().SetItemText(id, 2, str);
	str.Format("%d", bits);
	GetListCtrl().SetItemText(id, 3, str);
	str.Format("%dKB", size / 1024);
	GetListCtrl().SetItemText(id, 4, str);

	sec = (size / cha) / (bits / 8) / freq;
	TimeStrSet(&str, sec);
	GetListCtrl().SetItemText(id, 5, str);

	str.Format("%d", wave->volLevel);
	GetListCtrl().SetItemText(id, 6, str);

	TimeStrSet(&str, wave->FadeIn);
	GetListCtrl().SetItemText(id, 7, str);
	TimeStrSet(&str, wave->FadeOut);
	GetListCtrl().SetItemText(id, 8, str);

	TimeStrSet(&str, wave->SkipIn / wave->waveFormat.nAvgBytesPerSec);
	GetListCtrl().SetItemText(id, 9, str);
	TimeStrSet(&str, wave->SkipIn / wave->waveFormat.nAvgBytesPerSec);
	GetListCtrl().SetItemText(id, 10, str);
}

/////////////////////////////////////////////////////////////////////////////
// CWavListView NX̃bZ[W nh

void CWavListView::OnDropFiles(HDROP hDropInfo) 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ

	int no, max;
	char file[256];

	max = DragQueryFile(hDropInfo, -1, NULL, 0);
	for ( no = 0 ; no < max ; no++ ) {
		DragQueryFile(hDropInfo, no, file, 255);
		AddFile(file);
	}
	CListView::OnDropFiles(hDropInfo);
}

int CWavListView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
/*
	lpCreateStruct->style |= LVS_REPORT;

	DWORD dwStyle = SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0);
	dwStyle |= LVS_EX_FULLROWSELECT;
	SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, dwStyle);
*/
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;
	return 0;
}

void CWavListView::OnFileOpen() 
{
	char tmp[4096];
	POSITION pos;
	CFileDialog dlg(TRUE, "wav", NULL,
		OFN_ALLOWMULTISELECT | OFN_LONGNAMES | OFN_HIDEREADONLY,
		"Wave Files (*.wav)|*.wav|All Files (*.*)|*.*||",
		this);

	tmp[0] = '\0';
	dlg.m_ofn.lpstrFile = tmp;
	dlg.m_ofn.nMaxFile  = 4096;

	if ( dlg.DoModal() != IDOK )
		return;
	
	for ( pos = dlg.GetStartPosition() ; pos != NULL ; )
		AddFile(dlg.GetNextPathName(pos));
}

void CWavListView::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int n, i, x, a;
	RECT rect;
	int mx = GetListCtrl().GetItemCount();
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	for ( n = 0 ; n < mx ; n++ ) {
		if ( GetListCtrl().GetItemRect(n, &rect, LVIR_LABEL) &&
				pNMListView->ptAction.y >= rect.top &&
				pNMListView->ptAction.y < rect.bottom ) {
			for ( i = x = 0 ; (a = GetListCtrl().GetColumnWidth(i)) > 0 ; i++, x += a ) {
				if ( pNMListView->ptAction.x >= x &&
					 pNMListView->ptAction.x < (x + a) ) {
					for ( a = 0 ; a < mx ; a++ )
						GetListCtrl().SetItemState(a, 0, LVIS_SELECTED | LVIS_FOCUSED);
					GetListCtrl().SetItemState(n, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
					if ( i >= 9 )
						OnWaveCut();
					else if ( i >= 6 )
						OnWaveVolume();
					break;
				}
			}
			break;
		}
	}

	*pResult = 0;
}

void CWavListView::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int n;
	RECT rect;
	int mx = GetListCtrl().GetItemCount();
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	for ( n = 0 ; n < mx ; n++ )
		GetListCtrl().SetItemState(n, 0, LVIS_SELECTED | LVIS_FOCUSED);

	for ( n = 0 ; n < mx ; n++ ) {
		if ( GetListCtrl().GetItemRect(n, &rect, LVIR_LABEL) &&
				pNMListView->ptAction.y >= rect.top &&
				pNMListView->ptAction.y < rect.bottom ) {
			GetListCtrl().SetItemState(n, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
			OnWavePlay();
		}
	}

	*pResult = 0;
}

void CWavListView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	int n;
	RECT rect;
	int mx = GetListCtrl().GetItemCount();
	CMenu menu, *submenu;

	CListView::OnRButtonDown(nFlags, point);

	for ( n = 0 ; n < mx ; n++ )
		GetListCtrl().SetItemState(n, 0, LVIS_SELECTED | LVIS_FOCUSED);

	for ( n = 0 ; n < mx ; n++ ) {
		if ( GetListCtrl().GetItemRect(n, &rect, LVIR_LABEL) &&
				point.y >= rect.top &&
				point.y < rect.bottom ) {
			GetListCtrl().SetItemState(n, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
			menu.LoadMenu(IDR_MENU1);
			ClientToScreen(&point);
			if ( (submenu = menu.GetSubMenu(0)) != NULL )
				submenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, point.x, point.y, this);
			break;
		}
	}
}

void CWavListView::OnWavePlay() 
{
	int n;
	int max = GetListCtrl().GetItemCount();

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			if ( playWave != NULL )
				playWave->PlayEnd();
			playWave = waveTabBuff[GetListCtrl().GetItemData(n)];
			playWave->PlayStart();
			break;
		}
	}	
}

void CWavListView::OnWaveStop() 
{
	if ( playWave != NULL )
		playWave->PlayEnd();
	playWave = NULL;
}

void CWavListView::OnUpdateWavePlay(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(playWave == NULL && GetListCtrl().GetItemCount() > 0 ? TRUE : FALSE);
}

void CWavListView::OnUpdateWaveStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(playWave != NULL && playWave->PlayStatus() ? TRUE : FALSE);
}

void CWavListView::OnWaveVolreg() 
{
	int n;
	int max = GetListCtrl().GetItemCount();
	CWaveFile *wave;
	CString str;

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			wave = waveTabBuff[GetListCtrl().GetItemData(n)];
			wave->RegLevel();
			str.Format("%d", wave->volLevel);
			GetListCtrl().SetItemText(n, 6, str);
		}
	}	
}

void CWavListView::OnWaveVolume() 
{
	int n;
	int max = GetListCtrl().GetItemCount();
	CWaveFile *wave;
	CString str;
	CVolCtrl vol(this);

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			wave = waveTabBuff[GetListCtrl().GetItemData(n)];
			vol.m_Volume = wave->volLevel;
			vol.m_FadeIn = wave->FadeIn;
			vol.m_FadeOut = wave->FadeOut;
			if ( vol.DoModal() == IDOK ) {
				wave->volLevel = vol.m_Volume;
				wave->FadeIn   = vol.m_FadeIn;
				wave->FadeOut  = vol.m_FadeOut;
			}
			str.Format("%d", wave->volLevel);
			GetListCtrl().SetItemText(n, 6, str);
			str.Format("%d", wave->FadeIn);
			GetListCtrl().SetItemText(n, 7, (wave->FadeIn > 0 ? str : ""));
			str.Format("%d", wave->FadeOut);
			GetListCtrl().SetItemText(n, 8, (wave->FadeOut > 0 ? str : ""));
		}
	}	
}

void CWavListView::OnWaveCut() 
{
	int n;
	int max = GetListCtrl().GetItemCount();
	DWORD SkipIn, SkipOut;
	CWaveFile *wave;
	CString str;
	CSkipWave skip(this);

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			wave = waveTabBuff[GetListCtrl().GetItemData(n)];
			skip.pWave = wave;
			SkipIn = wave->SkipIn;
			SkipOut = wave->SkipOut;
			if ( skip.DoModal() != IDOK ) {
				wave->SkipIn = SkipIn;
				wave->SkipOut = SkipOut;
			}
			TimeStrSet(&str, wave->SkipIn / wave->waveFormat.nAvgBytesPerSec);
			GetListCtrl().SetItemText(n, 9, str);
			TimeStrSet(&str, wave->SkipOut / wave->waveFormat.nAvgBytesPerSec);
			GetListCtrl().SetItemText(n, 10, str);
		}
	}	
}

void CWavListView::OnFileSave() 
{
	int n, it;
	int max = GetListCtrl().GetItemCount();
	CWaveFile *wave;

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			it = GetListCtrl().GetItemData(n);
			wave = waveTabBuff[GetListCtrl().GetItemData(n)];
			if ( !wave->SaveFile() )
				MessageBox("t@C̕ۑɎs܂");
			else {
				delete wave;
				waveTabBuff[it] = NULL;
				GetListCtrl().DeleteItem(n);
				n--;
				max--;
			}
		}
	}
}

void CWavListView::OnFileMerge() 
{
	int n, i;
	int max = GetListCtrl().GetItemCount();
	CWaveFile wave(this);
	CWaveFile *wp;
	char tmp[MAXWAVEBUF];
	MSG msg;
	DWORD waveSize = 0L;
	DWORD saveSize = 0L;
	CStatusDialog status(this);
	CFileDialog dlg(TRUE, "wav", "Audio",
		OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
		"Wave Files (*.wav)|*.wav|All Files (*.*)|*.*||",
		this);

	for ( n = i = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			wp = waveTabBuff[GetListCtrl().GetItemData(n)];
			waveSize += wp->waveSize;
			if ( i == 0 )
				wave.waveFormat = wp->waveFormat;
			if ( wave.waveFormat.nChannels != wp->waveFormat.nChannels ||
				 wave.waveFormat.nSamplesPerSec != wp->waveFormat.nSamplesPerSec ||
				 wave.waveFormat.wBitsPerSample != wp->waveFormat.wBitsPerSample ) {
				MessageBox("ݒ̈ႤWAVEt@CĂ܂");
				return;
			}
			i++;
		}
	}

	if ( waveSize == 0 ) {
		MessageBox("WAVEt@CIĂ");
		return;
	}

	if ( dlg.DoModal() != IDOK )
		return;

	if ( !wave.CreateFile(dlg.GetFileName()) )
		return;

	status.m_Title = dlg.GetFileName();
	status.Create(IDD_STATUS_BAR, this);
	status.m_Progres.SetRange32(0, waveSize);
	status.ShowWindow(SW_SHOW);
	status.UpdateWindow();

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			wp = waveTabBuff[GetListCtrl().GetItemData(n)];
			if ( !wp->OpenFile(wp->fileName) )
				continue;

			while ( (i = wp->ReadData(tmp, MAXWAVEBUF)) > 0 ) {
				wave.WriteData(tmp, i);
				saveSize += i;
				status.m_Progres.SetPos(saveSize);
			    while ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) ) {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}

			wp->CloseFile();
		}
	}
	
	wave.AscendFile();
}

void CWavListView::OnEditCopy() 
{
	int n, i;
	int max = GetListCtrl().GetItemCount();
	CString file;
	CString str = "";
	HGLOBAL hData;
	char *pData;

	for ( n = 0 ; n < max ; n++ ) {
		if ( GetListCtrl().GetItemState(n, LVIS_SELECTED) ) {
			file = GetListCtrl().GetItemText(n, 0);
			if ( (i = file.ReverseFind('\\')) >= 0 )
				str += file.Mid(i + 1);
			else
				str += file;
			str += "\r\n";
		}
	}

	if ( str.IsEmpty() )
		return;

	if ( (hData = GlobalAlloc(GMEM_MOVEABLE, str.GetLength() + 1)) == NULL )
		return;

	if ( (pData = (char *)GlobalLock(hData)) == NULL ) {
		GlobalFree(hData);
		return;
	}

	strcpy(pData, str);
	GlobalUnlock(hData);

	if ( !OpenClipboard() ) {
		GlobalUnlock(hData);
		return;
	}

	if ( !EmptyClipboard() ) {
		CloseClipboard();
		GlobalUnlock(hData);
		return;
	}

	SetClipboardData(CF_TEXT, hData);
	CloseClipboard();
}

void CWavListView::TimeStrSet(CString *str, int t)
{
	if ( t >= (60 * 60) )
		str->Format("%d:%02d:%02d", t / 3600, (t % 3600) / 60, t % 60);
	else if ( t >= 60 )
		str->Format("%d:%02d", t / 60, t % 60);
	else
		str->Format("%d", t);
}

void CWavListView::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;

	if ( LastSortItem == pNMListView->iSubItem )
		CompareRevs ^= 1;
	else
		CompareRevs = 0;

	CompareDups = 0;
	LastSortItem = pNMListView->iSubItem;
	pCompList = &(GetListCtrl());
	pCompList->SortItems(CompareFunc, pNMListView->iSubItem);

	*pResult = 0;
}
