// SkipWave.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WavList.h"
#include "SkipWave.h"
#include "StatusDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSkipWave _CAO


CSkipWave::CSkipWave(CWnd* pParent /*=NULL*/)
	: CDialog(CSkipWave::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSkipWave)
	m_AfterSkip = 0;
	m_BeforeSkip = 0;
	//}}AFX_DATA_INIT
	pWave = NULL;
	tID = 0;
}


void CSkipWave::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSkipWave)
	DDX_Slider(pDX, IDC_AFTER_SKIP, m_AfterSkip);
	DDX_Slider(pDX, IDC_BEFORE_SKIP, m_BeforeSkip);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSkipWave, CDialog)
	//{{AFX_MSG_MAP(CSkipWave)
	ON_BN_CLICKED(IDC_BEFORE_PLAY, OnBeforePlay)
	ON_BN_CLICKED(IDC_AFTER_PLAY, OnAfterPlay)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_AFTER_SKIP, OnReleasedcaptureAfterSkip)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_BEFORE_SKIP, OnReleasedcaptureBeforeSkip)
	ON_WM_LBUTTONDOWN()
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_FILE_CUT, OnFileCut)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSkipWave bZ[W nh

void CSkipWave::UpdateViewBox(int ID)
{
	RECT rect;

	GetDlgItem(ID)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	InvalidateRect(&rect, FALSE);
}

BOOL CSkipWave::OnInitDialog() 
{
	CSliderCtrl *pSlider;

	CDialog::OnInitDialog();

	pSlider = (CSliderCtrl *)GetDlgItem(IDC_BEFORE_SKIP);
	pSlider->SetRange(0, pWave->waveSize, TRUE);
	m_BeforeSkip = pWave->SkipIn;
	pSlider->SetPos(m_BeforeSkip);

	pSlider = (CSliderCtrl *)GetDlgItem(IDC_AFTER_SKIP);
	pSlider->SetRange(0, pWave->waveSize, TRUE);
	m_AfterSkip = pWave->waveSize - pWave->SkipOut;
	pSlider->SetPos(m_AfterSkip);

	return FALSE;
}

void CSkipWave::OnBeforePlay() 
{
	UpdateData(TRUE);

	pWave->SetSkipIn(m_BeforeSkip);
	pWave->PlayStart();

	if ( tID != 0 )
		KillTimer(tID);
	tID = SetTimer(1, 3000, NULL);
}

void CSkipWave::OnAfterPlay() 
{
	DWORD pos;

	UpdateData(TRUE);

	if ( (DWORD)m_AfterSkip < (DWORD)(pWave->waveFormat.nAvgBytesPerSec * 3) )
		pos = 0;
	else
		pos = m_AfterSkip - pWave->waveFormat.nAvgBytesPerSec * 3;

	pWave->SetSkipIn(pos);
	pWave->SetSkipOut(m_AfterSkip);
	pWave->PlayStart();

	if ( tID != 0 )
		KillTimer(tID);
	tID = SetTimer(1, 3000, NULL);
}

void CSkipWave::OnReleasedcaptureBeforeSkip(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(TRUE);
	pWave->SetSkipIn(m_BeforeSkip);
	UpdateViewBox(IDC_BEFORE_ZOOM);
	*pResult = 0;
}

void CSkipWave::OnReleasedcaptureAfterSkip(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData(TRUE);
	pWave->SetSkipOut(m_AfterSkip);
	UpdateViewBox(IDC_AFTER_ZOOM);
	*pResult = 0;
}

void CSkipWave::OnOK() 
{
	UpdateData(TRUE);
	pWave->SetSkipIn(m_BeforeSkip);
	pWave->SetSkipOut(m_AfterSkip);
	CDialog::OnOK();
}

void CSkipWave::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int n;
	CRect rect;

	GetDlgItem(IDC_BEFORE_ZOOM)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	if ( rect.PtInRect(point) ) {
		n = (point.x - rect.left) * pWave->waveFormat.nAvgBytesPerSec / (rect.right - rect.left);
		m_BeforeSkip += (n - BeforeZpos);
		UpdateData(FALSE);
		InvalidateRect(&rect, FALSE);
	}

	GetDlgItem(IDC_AFTER_ZOOM)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	if ( rect.PtInRect(point) ) {
		n = (point.x - rect.left) * pWave->waveFormat.nAvgBytesPerSec / (rect.right - rect.left);
		m_AfterSkip += (n - AfterZpos);
		UpdateData(FALSE);
		InvalidateRect(&rect, FALSE);
	}

	CDialog::OnLButtonDown(nFlags, point);
}

void CSkipWave::OnTimer(UINT nIDEvent) 
{
	if ( tID != 0 )
		KillTimer(tID);

	pWave->PlayEnd();

	CDialog::OnTimer(nIDEvent);
}

void CSkipWave::OnPaint() 
{
	CRect box;
	RECT rect;
	CPaintDC dc(this); // `p̃foCX ReLXg

	UpdateData(TRUE);

	GetDlgItem(IDC_BEFORE_ZOOM)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	if ( box.IntersectRect(&rect, &(dc.m_ps.rcPaint)) ) {
		rect.left += 2; rect.right  -= 2;
		rect.top  += 2; rect.bottom -= 2;
		BeforeZpos = pWave->DrawLine(&dc, &rect, m_BeforeSkip);
	}

	GetDlgItem(IDC_AFTER_ZOOM)->GetWindowRect(&rect);
	ScreenToClient(&rect);
	if ( box.IntersectRect(&rect, &(dc.m_ps.rcPaint)) ) {
		rect.left += 2; rect.right  -= 2;
		rect.top  += 2; rect.bottom -= 2;
		AfterZpos = pWave->DrawLine(&dc, &rect, m_AfterSkip);
	}
}

void CSkipWave::OnFileCut() 
{
	int i;
	MSG msg;
	DWORD saveSize = 0;
	char tmp[MAXWAVEBUF];
	CWaveFile wave(this);
	CStatusDialog status(this);
	CFileDialog dlg(TRUE, "wav", "Audio",
		OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
		"Wave Files (*.wav)|*.wav|All Files (*.*)|*.*||",
		this);

	if ( dlg.DoModal() != IDOK )
		return;

	UpdateData(TRUE);
	pWave->SetSkipIn(m_BeforeSkip);
	pWave->SetSkipOut(m_AfterSkip);

	if ( !wave.CreateFile(dlg.GetFileName()) )
		return;

	status.m_Title = dlg.GetFileName();
	status.Create(IDD_STATUS_BAR, this);
	status.m_Progres.SetRange32(0, pWave->waveSize);
	status.ShowWindow(SW_SHOW);
	status.UpdateWindow();

	if ( !pWave->OpenFile(pWave->fileName) )
		return;

	while ( (i = pWave->ReadData(tmp, MAXWAVEBUF)) > 0 ) {
		wave.WriteData(tmp, i);
		saveSize += i;

		status.m_Progres.SetPos(saveSize);
		while ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	pWave->CloseFile();
	wave.AscendFile();	
}
