// WaveFile.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "WavList.h"
#include "WaveFile.h"
#include "StatusDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWaveFile

CWaveFile::CWaveFile(CWnd *Wnd)
{
	int n;

	pWnd = Wnd;
	hmmio = NULL;
	hWaveOut = NULL;
	fileName = "";
	listName = "";

	memset(&waveFormat, 0, sizeof(WAVEFORMATEX));
	waveSize = 0L;
	maxLevel = (-1);
	volLevel = MAXVOLUME;
	FadeIn = FadeOut = 0;
	SkipIn = SkipOut = 0;
	stopFlag = TRUE;

	for ( n = 0 ; n < MAXWAVEHDR ; n++ )
		waveHdrTab[n].lpData = NULL;
}

CWaveFile::~CWaveFile()
{
	int n;

	if ( hWaveOut != NULL ) {
		waveOutReset(hWaveOut);
		for ( n = 0 ; n < MAXWAVEHDR ; n++ ) {
			if ( waveHdrTab[n].lpData != NULL )
				waveOutUnprepareHeader(hWaveOut, &(waveHdrTab[n]), sizeof(WAVEHDR));
		}
		waveOutClose(hWaveOut);
	}

	if ( hmmio != NULL )
		mmioClose(hmmio, 0);
}

BEGIN_MESSAGE_MAP(CWaveFile, CWnd)
	//{{AFX_MSG_MAP(CWaveFile)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
        ON_MESSAGE(MM_WOM_DONE, OnWaveOutData)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWaveFile bZ[W nh

int CWaveFile::OpenFile(LPCSTR file)
{
    PCMWAVEFORMAT pcmWave;

	if ( (hmmio = mmioOpen((LPSTR)file, NULL, MMIO_READ | MMIO_ALLOCBUF)) == NULL )
		return FALSE;

	mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
	if ( mmioDescend(hmmio, (LPMMCKINFO)(&mmckinfoParent), NULL, MMIO_FINDRIFF) )
		goto ERRORRET;

/***
	mmckinfoSubchunk.ckid = mmioFOURCC('L', 'I', 'S', 'T');
	if ( !mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK) ) {
		MMCKINFO mmckinfoListchunk;
		mmckinfoListchunk.ckid = mmioFOURCC('I', 'C', 'O', 'P');
		if ( !mmioDescend(hmmio, &mmckinfoListchunk, &mmckinfoSubchunk, MMIO_FINDLIST) ) {
			mmioAscend(hmmio, &mmckinfoListchunk, 0);
		}
		mmioAscend(hmmio, &mmckinfoSubchunk, 0);
	}
****/

	mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
	if ( mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK) )
		goto ERRORRET;

	if ( mmioRead(hmmio, (LPSTR)&pcmWave, mmckinfoSubchunk.cksize) != (LRESULT)mmckinfoSubchunk.cksize )
		goto ERRORRET;

	if ( pcmWave.wf.wFormatTag != WAVE_FORMAT_PCM )
		goto ERRORRET;

	mmioAscend(hmmio, &mmckinfoSubchunk, 0);

	mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
	if ( mmioDescend(hmmio, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK) )
		goto ERRORRET;

	if ( mmckinfoSubchunk.cksize == 0 )
		goto ERRORRET;

    waveFormat.wFormatTag      = pcmWave.wf.wFormatTag;
    waveFormat.nChannels       = pcmWave.wf.nChannels;
    waveFormat.nSamplesPerSec  = pcmWave.wf.nSamplesPerSec;
	waveFormat.nBlockAlign     = pcmWave.wf.nBlockAlign;
    waveFormat.nAvgBytesPerSec = pcmWave.wf.nAvgBytesPerSec;
	waveFormat.wBitsPerSample  = pcmWave.wBitsPerSample;
    waveFormat.cbSize          = 0;
	waveSize = mmckinfoSubchunk.cksize;
	playSize = 0;

	return TRUE;

ERRORRET:
    mmioClose(hmmio, 0);
	hmmio = NULL;
    return FALSE;
}

void CWaveFile::CloseFile()
{
	if ( hmmio != NULL )
	    mmioClose(hmmio, 0);
	hmmio = NULL;
}

int CWaveFile::InitFile(LPCSTR file)
{
	fileName = file;

	if ( !OpenFile(fileName) )
		return FALSE;

	CloseFile();

	return TRUE;
}

int CWaveFile::PlayStart()
{
    int n, i;
    WAVEHDR *pwh;
    RECT rect;
	DWORD Size;

	if ( hWaveOut != NULL )
		PlayEnd();

	if ( !OpenFile(fileName) )
		return FALSE;

    memset(&rect, 0, sizeof(RECT));
    if ( !Create(NULL, "WaveFile", WS_CHILD, rect, pWnd, 0, NULL) ) {
		CloseFile();
		return FALSE;
	}
    
	if ( waveOutOpen(&hWaveOut, WAVE_MAPPER, &waveFormat, (DWORD)(m_hWnd), 0L, CALLBACK_WINDOW)) {
		CloseFile();
		DestroyWindow();
		return FALSE;
	}

	if ( SkipIn > 0 )
		Size = mmioSeek(hmmio, SkipIn, SEEK_CUR);
	Size = waveSize - SkipIn - SkipOut;
	playSize = 0;
	stopFlag = FALSE;

    for ( n = 0 ; n < MAXWAVEHDR ; n++ ) {
		pwh = &(waveHdrTab[n]);
        memset(pwh, 0, sizeof(WAVEHDR));
		pwh->lpData          = waveBuffer[n];
		pwh->dwBufferLength  = MAXWAVEBUF;
		pwh->dwBytesRecorded = 0;
		pwh->dwFlags         = 0;
		pwh->dwLoops         = 0;
		pwh->dwUser          = n;
		if( waveOutPrepareHeader(hWaveOut, pwh, sizeof(WAVEHDR))) {
			pwh->lpData = NULL;
		    goto ERRORRET;
		}
		if ( playSize < Size ) {
			if ( (i = (Size - playSize)) > (int)(pwh->dwBufferLength) )
				i = pwh->dwBufferLength;
			if( (i = mmioRead(hmmio, pwh->lpData, i)) > 0 ) {
				pwh->dwBufferLength  = i;
				VolumeCalc(playSize, i, pwh->lpData);
				if ( waveOutWrite(hWaveOut, pwh, sizeof(WAVEHDR)) )
					goto ERRORRET;
				playSize += i;
			}
		}
	}

	return TRUE;

ERRORRET:
	stopFlag = TRUE;
	waveOutReset(hWaveOut);
    for ( n = 0 ; n < MAXWAVEHDR ; n++ ) {
		if ( waveHdrTab[n].lpData != NULL )
			waveOutUnprepareHeader(hWaveOut, &(waveHdrTab[n]), sizeof(WAVEHDR));
		waveHdrTab[n].lpData = NULL;
	}
    waveOutClose(hWaveOut);
	hWaveOut = NULL;
	CloseFile();
	DestroyWindow();
    return FALSE;
}

int CWaveFile::PlayStatus()
{
	int n;

	if ( hWaveOut == NULL )
		return FALSE;
    for ( n = 0 ; n < MAXWAVEHDR ; n++ ) {
		if ( waveHdrTab[n].lpData != NULL )
			return TRUE;
	}
	return FALSE;
}

void CWaveFile::PlayEnd()
{
	int n;

	stopFlag = TRUE;
	if ( hWaveOut != NULL ) {
		waveOutReset(hWaveOut);
		for ( n = 0 ; n < MAXWAVEHDR ; n++ ) {
			if ( waveHdrTab[n].lpData != NULL )
				waveOutUnprepareHeader(hWaveOut, &(waveHdrTab[n]), sizeof(WAVEHDR));
			waveHdrTab[n].lpData = NULL;
		}
		waveOutClose(hWaveOut);
		hWaveOut = NULL;
	}
	CloseFile();
	DestroyWindow();
}

void CWaveFile::OnWaveOutData(WPARAM wParam, LPARAM lParam)
{
	int i;
	WAVEHDR *pwh = (WAVEHDR *)lParam;
	DWORD Size = waveSize - SkipIn - SkipOut;
	
	if ( stopFlag ) {
		if ( pwh->lpData != NULL )
			waveOutUnprepareHeader(hWaveOut, pwh, sizeof(WAVEHDR));
		pwh->lpData = NULL;
		return;
	}

	pwh->dwFlags = 0;
	pwh->dwLoops = 0;

	if ( (Size - playSize) > MAXWAVEBUF )
		i = MAXWAVEBUF;
	else {
		i = (int)(Size - playSize);
		stopFlag = TRUE;
	}

	if( (i = mmioRead(hmmio, pwh->lpData, i)) > 0 ) {
		pwh->dwBufferLength  = i;
		VolumeCalc(playSize, i, pwh->lpData);
		if ( waveOutWrite(hWaveOut, pwh, sizeof(WAVEHDR)) )
			return;
		playSize += i;
	} else
		stopFlag = TRUE;
}

void CWaveFile::VolumeCalc(DWORD pos, int len, char *buff)
{
	int n, vol, ext;
	int mx = (len / waveFormat.nBlockAlign) * waveFormat.nChannels;
	short *sp = (short *)buff;
	unsigned char *cp = (unsigned char *)buff;
	DWORD Size = waveSize - SkipIn - SkipOut;
	DWORD fmx  = Size / waveFormat.nBlockAlign;
	DWORD fin  = waveFormat.nSamplesPerSec * FadeIn;
	DWORD fout = waveFormat.nSamplesPerSec * FadeOut;

	pos /= waveFormat.nBlockAlign;

	ext = volLevel;

	if ( pos < fin )
		ext = ext * pos / fin;

	if ( pos > (fmx - fout) )
		ext = ext * (fmx - pos) / fout;

	if ( ext == MAXVOLUME )
		return;

	switch(waveFormat.wBitsPerSample) {
	case 8:
		for ( n = 0 ; n < mx ; n++ ) {
			vol = *cp - 128;
			vol = vol * ext / MAXVOLUME;

			if ( vol > 127 )
				vol = 127;
			else if ( vol < -128 )
				vol = -128;

			*(cp++) = (unsigned char)(vol + 128);
		}
		break;
	case 16:
		for ( n = 0 ; n < mx ; n++ ) {
			vol = *sp;
			vol = vol * ext / MAXVOLUME;

			if ( vol > 32767 )
				vol = 32767;
			else if ( vol < -32768 )
				vol = -32768;
			
			*(sp++) = (short)vol;
		}
		break;
	}
}

int CWaveFile::MaxLevel()
{
	int n, mx, vol;
	DWORD sz, Size;
	char tmp[4096];
	short *sp;
	unsigned char *cp;
	CStatusDialog status(this);

	if ( maxLevel >= 0 )
		return maxLevel;

	if ( !OpenFile(fileName) )
		return (-1);

	status.m_Title = fileName;

	if ( !status.Create(IDD_STATUS_BAR, this) )
		return (-1);

	if ( SkipIn > 0 )
		mmioSeek(hmmio, SkipIn, SEEK_CUR);
	Size = waveSize - SkipIn - SkipOut;

	status.m_Progres.SetRange32(0, Size);
	status.ShowWindow(SW_SHOW);
	status.UpdateWindow();

	maxLevel = 0;

	for ( sz = 0 ; sz < Size ; sz += 4096 ) {
		if ( (Size - sz) > 4096 )
			n = 4096;
		else
			n = (int)(Size - sz);

		if( (n = mmioRead(hmmio, tmp, n)) <= 0 )
			break;

		mx = (n / waveFormat.nBlockAlign) * waveFormat.nChannels;

		switch(waveFormat.wBitsPerSample) {
		case 8:
			cp = (unsigned char *)tmp;
			for ( n = 0 ; n < mx ; n++ ) {
				if ( (vol = GetLevel(*(cp++) - 128)) > maxLevel )
					maxLevel = vol;
			}
			break;
		case 16:
			sp = (short *)tmp;
			for ( n = 0 ; n < mx ; n++ ) {
				if ( (vol = GetLevel(*(sp++))) > maxLevel )
					maxLevel = vol;
			}
			break;
		}

		status.m_Progres.SetPos(sz);

		MSG msg;
	    while ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	CloseFile();
	return maxLevel;
}

void CWaveFile::RegLevel()
{
	int max = 1 << (waveFormat.wBitsPerSample - 1);

	if ( MaxLevel() <= 0 )
		return;

	volLevel = MAXVOLUME * max / maxLevel;
}

int CWaveFile::SaveFile()
{
	int n;
	HMMIO hnewio;
	CString file;
	MMCKINFO newckinfoParent;
	MMCKINFO newckinfoSubchunk;
    PCMWAVEFORMAT pcmWave;
	DWORD sz;
	char tmp[MAXWAVEBUF];
	CStatusDialog status(this);
	DWORD Size;

	if ( volLevel == MAXVOLUME &&
		 FadeIn == 0 && FadeOut == 0 &&
		 SkipIn == 0 && SkipOut == 0 )
		return TRUE;

	file = fileName;
	file += ".$$$";

	if ( PlayStatus() )
		PlayEnd();

	if ( !OpenFile(fileName) )
		return FALSE;

    if( (hnewio = mmioOpen((LPSTR)((LPCSTR)file), NULL, MMIO_WRITE | MMIO_CREATE)) == NULL)
		return FALSE;

    memset(&newckinfoParent, 0, sizeof(MMCKINFO));
    memset(&newckinfoSubchunk, 0, sizeof(MMCKINFO));

    newckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
    if ( mmioCreateChunk(hnewio, &newckinfoParent, MMIO_CREATERIFF) )
		goto ERRORRET;

    newckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
    newckinfoSubchunk.cksize = sizeof(PCMWAVEFORMAT);
    if ( mmioCreateChunk(hnewio, &newckinfoSubchunk, 0) )
		goto ERRORRET;

    pcmWave.wf.wFormatTag      = waveFormat.wFormatTag;
    pcmWave.wf.nChannels       = waveFormat.nChannels;
    pcmWave.wf.nSamplesPerSec  = waveFormat.nSamplesPerSec;
    pcmWave.wf.nBlockAlign     = waveFormat.nBlockAlign;
    pcmWave.wf.nAvgBytesPerSec = waveFormat.nAvgBytesPerSec;
    pcmWave.wBitsPerSample     = waveFormat.wBitsPerSample;

    if ( mmioWrite(hnewio, (LPCSTR)&pcmWave, sizeof(PCMWAVEFORMAT)) != sizeof(PCMWAVEFORMAT) )
		goto ERRORRET;

    mmioAscend(hnewio, &newckinfoSubchunk, 0);
    newckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
    if ( mmioCreateChunk(hnewio, &newckinfoSubchunk, 0) )
		goto ERRORRET;

	if ( SkipIn > 0 )
		mmioSeek(hmmio, SkipIn, SEEK_CUR);
	Size = waveSize - SkipIn - SkipOut;

	status.m_Title = fileName;
	status.Create(IDD_STATUS_BAR, this);
	status.m_Progres.SetRange32(0, Size);
	status.ShowWindow(SW_SHOW);
	status.UpdateWindow();

	for ( sz = 0 ; sz < Size ; sz += MAXWAVEBUF ) {
		if ( (Size - sz) > MAXWAVEBUF )
			n = MAXWAVEBUF;
		else
			n = (int)(Size - sz);

		if( (n = mmioRead(hmmio, tmp, n)) <= 0 )
			break;

		VolumeCalc(sz, n, tmp);

		if ( mmioWrite(hnewio, tmp, n) != n )
			break;

		status.m_Progres.SetPos(sz);

		MSG msg;
	    while ( PeekMessage(&msg, 0, 0, 0, PM_REMOVE) ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if ( sz < Size )
		goto ERRORRET;

	mmioAscend(hnewio, &newckinfoSubchunk, 0);
	mmioAscend(hnewio, &newckinfoParent, 0);
    mmioClose(hnewio, 0);
	CloseFile();

	volLevel = MAXVOLUME;
	FadeIn = FadeOut = 0;
	SkipIn = SkipOut = 0;

	if ( unlink(fileName) || rename(file, fileName) )
		return FALSE;

	return TRUE;

ERRORRET:
	CloseFile();
    mmioClose(hnewio, 0);
	unlink(file);
    return FALSE;
}

int CWaveFile::CreateFile(LPCSTR file)
{
    PCMWAVEFORMAT pcmWave;

    if( (hmmio = mmioOpen((LPSTR)file, NULL, MMIO_WRITE | MMIO_CREATE)) == NULL)
		return FALSE;

    memset(&mmckinfoParent, 0, sizeof(MMCKINFO));
    memset(&mmckinfoSubchunk, 0, sizeof(MMCKINFO));

    mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');
    if ( mmioCreateChunk(hmmio, &mmckinfoParent, MMIO_CREATERIFF) )
		goto ERRORRET;

    mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
    mmckinfoSubchunk.cksize = sizeof(PCMWAVEFORMAT);
    if ( mmioCreateChunk(hmmio, &mmckinfoSubchunk, 0) )
		goto ERRORRET;

    pcmWave.wf.wFormatTag      = waveFormat.wFormatTag;
    pcmWave.wf.nChannels       = waveFormat.nChannels;
    pcmWave.wf.nSamplesPerSec  = waveFormat.nSamplesPerSec;
    pcmWave.wf.nBlockAlign     = waveFormat.nBlockAlign;
    pcmWave.wf.nAvgBytesPerSec = waveFormat.nAvgBytesPerSec;
    pcmWave.wBitsPerSample     = waveFormat.wBitsPerSample;

    if ( mmioWrite(hmmio, (LPCSTR)&pcmWave, sizeof(PCMWAVEFORMAT)) != sizeof(PCMWAVEFORMAT) )
		goto ERRORRET;

    mmioAscend(hmmio, &mmckinfoSubchunk, 0);
    mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
    if ( mmioCreateChunk(hmmio, &mmckinfoSubchunk, 0) )
		goto ERRORRET;

	return TRUE;

ERRORRET:
    mmioClose(hmmio, 0);
	hmmio = NULL;
    return FALSE;
}

void CWaveFile::AscendFile()
{
	mmioAscend(hmmio, &mmckinfoSubchunk, 0);
	mmioAscend(hmmio, &mmckinfoParent, 0);
    mmioClose(hmmio, 0);
	hmmio = NULL;
}

int CWaveFile::ReadData(void *buff, int len)
{
	int n;
	DWORD Size = waveSize - SkipIn - SkipOut;

	if ( (Size - playSize) < (DWORD)len )
		len = (int)(Size - playSize);

	if ( (n = mmioRead(hmmio, (char *)buff, len)) > 0 )
		VolumeCalc(playSize, n, (char *)buff);

	playSize += len;
	return n;
}

int CWaveFile::WriteData(void *buff, int len)
{
	waveSize += len;
	return mmioWrite(hmmio, (char *)buff, len);
}

int CWaveFile::DrawLine(CDC *pDC, RECT *pRect, DWORD entry)
{
	int n, x, y, nx, ny, by;
	int max, vol;
	int width, height;
	DWORD pos;
	char *tmp;
	unsigned char *cp;
	short *sp;
	int size = waveFormat.nAvgBytesPerSec;

	PlayEnd();

	if ( !OpenFile(fileName) )
		return 0;

	if ( (tmp = new char[size]) == NULL )
		return 0;

	if ( entry < (DWORD)(size / 2) )
		pos = 0;
	else
		pos = entry - size / 2;

	if ( (pos + size) >= waveSize ) {
		if ( waveSize < (DWORD)size )
			pos = 0;
		else
			pos = waveSize - size;
	}

	pos = (pos / waveFormat.nBlockAlign) * waveFormat.nBlockAlign;

	mmioSeek(hmmio, pos, SEEK_CUR);
	max = mmioRead(hmmio, tmp, size) / waveFormat.nBlockAlign;
	cp = (unsigned char *)tmp;
	sp = (short *)tmp;
	width = pRect->right - pRect->left - 1;
	height = pRect->bottom - pRect->top - 1;

	pDC->FillSolidRect(pRect, RGB(192, 192, 192));

	switch(waveFormat.nChannels) {
	case 1:
		switch(waveFormat.wBitsPerSample) {
		case 8:
			pDC->MoveTo(pRect->left, pRect->top + height / 2);
			for ( n = 0 ; n < max ; n++ ) {
				vol = *(cp++) - 128;
				pDC->LineTo(pRect->left + n * width / max,
						    pRect->top + height / 2 + vol * height / 254);
			}
			break;
		case 16:
			pDC->MoveTo(pRect->left, pRect->top + height / 2);
			for ( n = 0 ; n < max ; n++ ) {
				vol = *(sp++) / 256;
				pDC->LineTo(pRect->left + n * width / max,
						    pRect->top + height / 2 + vol * height / 254);
			}
			break;
		}
		break;
	case 2:
		switch(waveFormat.wBitsPerSample) {
		case 8:
			pDC->MoveTo(pRect->left, pRect->top + height / 4);
			for ( n = 0 ; n < max ; n++ ) {
				vol = *(cp++) - 128; cp++;
				pDC->LineTo(pRect->left + n * width / max,
						    pRect->top + height / 4 + vol * height / 508);
			}
			cp = (unsigned char *)tmp;
			pDC->MoveTo(pRect->left, pRect->top + height * 3 / 4);
			for ( n = 0 ; n < max ; n++ ) {
				cp++; vol = *(cp++) - 128;
				pDC->LineTo(pRect->left + n * width / max,
						    pRect->top + height * 3 / 4 + vol * height / 508);
			}
			break;
		case 16:
			nx = x = pRect->left;
			ny = by = y = pRect->top + height / 4;
			pDC->MoveTo(x, y);
			for ( n = 0 ; n < max ; n++ ) {
				vol = *(sp++) / 256; sp++;
				x = pRect->left + n * width / max;
				y = pRect->top + height / 4 + vol * height / 508;
				if ( x != nx ) {
					pDC->LineTo(nx, by);
					pDC->LineTo(nx, ny);
					nx = x; ny = by = y;
				} else if ( y > ny )
					ny = y;
				else if ( y < by )
					by = y;
			}
			pDC->LineTo(nx, by);
			pDC->LineTo(nx, ny);
		
			sp = (short *)tmp;
			nx = x = pRect->left;
			ny = by = y = pRect->top + height * 3 / 4;
			pDC->MoveTo(x, y);
			for ( n = 0 ; n < max ; n++ ) {
				sp++; vol = *(sp++) / 256;
				x = pRect->left + n * width / max;
				y = pRect->top + height * 3 / 4 + vol * height / 508;
				if ( x != nx ) {
					pDC->LineTo(nx, by);
					pDC->LineTo(nx, ny);
					nx = x; ny = by = y;
				} else if ( y > ny )
					ny = y;
				else if ( y < by )
					by = y;
			}
			pDC->LineTo(nx, by);
			pDC->LineTo(nx, ny);
			break;
		}
		break;
	}

	n = (int)(entry - pos);
	pRect->left += (n * width / size);
	pRect->right = pRect->left + 1;
	pDC->FillSolidRect(pRect, RGB(255, 0, 0));
	delete tmp;
	CloseFile();

	return n;
}

void CWaveFile::SetSkipIn(DWORD val)
{
	SkipIn = (val / waveFormat.nBlockAlign) * waveFormat.nBlockAlign;
	if ( SkipIn > (waveSize - SkipOut) )
		SkipOut = waveSize - SkipIn;
}

void CWaveFile::SetSkipOut(DWORD val)
{
	SkipOut = ((waveSize - val) / waveFormat.nBlockAlign) * waveFormat.nBlockAlign;
	if ( SkipIn > (waveSize - SkipOut) )
		SkipIn = waveSize - SkipOut;
}
